function sol=real_uexpost_h1st(param,Names)
% RBC, hours chosen in first stage
for i=1:length(Names)
    eval([Names{i} '_=param(i);'])
end
ksy     = alpha_*beta_/((1+mkup_)*(1-beta_*(1-delta_)));
isy     = delta_*ksy;
csy     = 1-isy;
ra1_    = min(ra1_,1-1e-12);
R       = ra1_;
Q       = rs1_;
D       = 1;
SIG     = blkdiag(sea_,ses_);
Me      = [1 0;0 1];
ny      = 2;
nb      = 1;
nf      = 6;
ne      = size(Me,1)-1;
nz      = size(Me,2);
Myy     = zeros(ny,ny);
Myx     = zeros(ny,nb);
MyX     = zeros(ny,nb);
MyY     = zeros(ny,ny);
Myf     = zeros(ny,nf);
MyF     = zeros(ny,nf);
Mys     = zeros(ny,ne);

Mxx0    = zeros(nb,nb);
Mxx1    = zeros(nb,nb);
MxX1    = zeros(nb,nb);
Mxy1    = zeros(nb,ny);
MxY1    = zeros(nb,ny);
Mxf1    = zeros(nb,nf);
MxF1    = zeros(nb,nf);
Mxs1    = zeros(nb,ne);

Mff0    = zeros(nf,nf);
Mff1    = zeros(nf,nf);
MfF0    = zeros(nf,nf);
MfF1    = zeros(nf,nf);
Mfx0    = zeros(nf,nb);
Mfx1    = zeros(nf,nb);
MfX1    = zeros(nf,nb);
Mfy0    = zeros(nf,ny);
Mfy1    = zeros(nf,ny);
MfY0    = zeros(nf,ny);
MfY1    = zeros(nf,ny);
Mfs0    = zeros(nf,ne);
Mfs1    = zeros(nf,ne);

% h w
% 1 2
%
% k
% 1
%
% lb y c x u rr Elb
% 1  2 3 4 5 6  7
%
% Hours
Myy(1,1)    = 1+sigh_;
Myf(1,1)    = 1;
Myf(1,2)    = 1-rho_;
MyF(1,2)    = rho_;
% Real Wage
Myy(2,1)    = sigh_;
Myy(2,2)    =-1;
Myf(2,1)    = 1;
% Capital
Mxx0(1,1)   = 1;
Mxx1(1,1)   = 1-delta_;
Mxf1(1,3)   = delta_;
% Lambda
Mff0(1,1)   = 1;
Mff0(1,2)   = (1-beta_*(1-delta_))*(1-rho_);
Mff0(1,5)   =-(1-beta_*(1-delta_));
MfF0(1,2)   =-(1-beta_*(1-delta_))*rho_;
Mfx0(1,1)   = (1-beta_*(1-delta_));
Mff1(1,1)   = 1;
% Output
Mff1(2,2)   = 1;
Mff1(2,5)   =-alpha_;
Mfx1(2,1)   =-alpha_;
Mfy1(2,1)   = alpha_-1;
Mfs1(2,1)   =-1;
% x
Mff1(3,2)   = (1-rho_);
MfF1(3,2)   = rho_;
Mff1(3,3)   =-isy;
Mff1(3,4)   =-csy;
Mff1(3,5)   =-alpha_/(1+mkup_);
% c
Mff1(4,1)   = 1;
Mff1(4,4)   = sigc_;
% Utilisation
Mff1(5,2)   = (1-sigz_)*(1-rho_);
MfF1(5,2)   = (1-sigz_)*rho_;
Mff1(5,5)   =-1;
Mfx1(5,1)   =-(1-sigz_);
% Real Interest Rate
Mff1(6,6)   = 1;
Mff0(6,1)   = 1;
Mff1(6,1)   =-1;

% Defining the model
%
model.myy   = Myy;
model.myx   = Myx;
model.myX   = MyX;
model.myY   = MyY;
model.myf   = Myf;
model.myF   = MyF;
model.mys   = Mys;

model.mxx0  = Mxx0;
model.mxx1  = Mxx1;
model.mxX1  = MxX1;
model.mxy1  = Mxy1;
model.mxY1  = MxY1;
model.mxf1  = Mxf1;
model.mxF1  = MxF1;
model.mxs1  = Mxs1;

model.mff0  = Mff0;
model.mff1  = Mff1;
model.mfF0  = MfF0;
model.mfF1  = MfF1;
model.mfy0  = Mfy0;
model.mfy1  = Mfy1;
model.mfY0  = MfY0;
model.mfY1  = MfY1;
model.mfx0  = Mfx0;
model.mfx1  = Mfx1;
model.mfX1  = MfX1;
model.mfs0  = Mfs0;
model.mfs1  = Mfs1;
model.r     = R;
model.q     = Q;
model.Delta = D;

% h w lb y x c u rr
% 1 2 3  4 5 6 7 8
iy          = 4;
ic          = 6;
ix          = 5;
ih          = 1;
iu          = 7;
iw          = 2;
irr         = 8;
nfor        = 1;
sol         = solve_beliefs(model,nfor);
if sol.id==0
    sol.me      = [zeros(nb,nz);Me];
    sol.sig     = SIG*SIG;
    sol.me      = [0 0;1 0;sba_ 1];
    
    drh         = sol.my(ih,:);
    dru         = sol.my(iu,:);
    dra         = [0 1 0];
    drc         = sol.my(ic,:);
    dri         = sol.my(ix,:);
    dry         = csy*sol.my(ic,:)+isy*sol.my(ix,:);
    drtfp       = sol.my(iy,:)-alpha_*[1 0 0]-(1-alpha_)*sol.my(ih,:);
    drysh       = dry-drh;
    drfsh       = sol.my(iy,:)-sol.my(ih,:);
    drw         = sol.my(iw,:);
    drrr        = sol.my(irr,:);
    MY1         = sol.my*sol.mx;
    drc1        = MY1(ic,:);
    dry1        = MY1(iy,:);
    dru1        = MY1(iu,:);
    drk1        = sol.mx(1,:);

    
    sol.my      = [dry;drc;dri;drh;drysh;drtfp;drw;drrr;dru];
    if isfield(sol,'myf')
        for i=1:nfor
            sol.myf{i}  = sol.myf{i}(iy,:);
        end
    end
end
