function model_output(theta,ficm,data,graph,file)

[mommod,sol]= feval(ficm,theta,data);
irfs        = comp_irf(sol,[0;1],data.hor);
irfa        = comp_irf(sol,[1;0],data.hor);
if graph.irf
    irfplot(irfs,irfa,file.irf)
end
for i=1:length(data.nfix)
    eval([data.nfix{i} '=data.pfix(i);'])
end
for i=1:length(data.nest)
    if data.pos(i)
        tmp = sqrt(theta(i)*theta(i));
    else
        tmp = theta(i);
    end
    eval([data.nest{i} '=tmp;'])
end
vdec        = ses*ses*cumsum(irfs.^2)./(sea*sea*cumsum(irfa.^2)+ses*ses*cumsum(irfs.^2));
ih          = [1 4 8 20];
vdec        = 100*vdec(ih,1:5);
disp(repmat('=',1,40))
for i=1:4
    fprintf('%2d & %6.2f & %6.2f & %6.2f & %6.2f & %6.2f \\\\ \n',ih(i),vdec(i,:))
end
disp(repmat('=',1,40))
for i=1:length(mommod);
    fprintf('& %8.4f \n',mommod(i));
end
