function graph_shocks(model,data,TH,file)
data_confidence;
load('../datatomatch/data60Q107Q4');
sol     = feval(model.name,mean(TH));
sol.my  = sol.my(model.select,:);
ks      = kalman_smoother(data,sol);

tfpdat  = (ltfpu);
mcidat  = standardize(conf);
tfpmod  = (ks.x(:,5)/100);
mcimod  = standardize(ks.x(:,10));

subplot(221);plot(1980,0);%set(gca,'xlim',[1960 2007.75],'ylim',[-0.125 0.125])
set(gca,'xlim',[1960 2007.75],'ylim',[-0.2 0.2])
hold on;
h=plot_nber([tfpmod tfpdat],1960,2007.75);
set(h(1),'linewidth',1.5,'color','k')
set(h(2),'linewidth',1.5,'color','r')
o=legend(h,'Technology Shock','Adj. Solow Res.','location','NorthEast');
set(o,'fontname','times','fontsize',10)
hold off
subplot(222);plot(1980,0);set(gca,'xlim',[1960 2007.75],'ylim',[-4 4]);hold on
h=plot_nber([mcimod mcidat],1960,2007.75);
set(h(1),'linewidth',1.5,'color','k')
set(h(2),'linewidth',1.5,'color','r')
o=legend(h,'Belief Shock','Consumer Confidence','location','NorthWest');
set(o,'fontname','times','fontsize',10)
hold off

printpdf(file);
close