function smooth=mshock_kalman_full(param,model,step,fixed,ith,ifix,file,ia,ixi,X)

load(file);
whos
ltfpu       = detrend(ltfpu,1);
% wdg         = (wedge1-mean(wedge1))/std(wedge1);
ltfp        = detrend(ltfp,1);
% X(:,2)      = ltfp;
T           = length(ly);
data_confidence;
cf          = detrend(conf,0)/std(conf);

[N,npar]    = size(param);
nfix        = size(fixed(:),1);
idth        = 1:step:N;
N           = length(idth);

th          = zeros(npar+nfix,1);
th(ifix)    = fixed(:);
th(ith)     = mean(param);

wdg         = detrend(th(4)*lh+lc-lysh,1);
wdg         = (wdg-mean(wdg))/std(wdg);

res     = ols(cf,[ones(length(cf),1) ltfpu]);
ycf     = (res.resid-mean(res.resid))/std(res.resid);
res     = ols(wdg,[ones(length(cf),1) ltfpu]);
ylw     = (res.resid-mean(res.resid))/std(res.resid);


sol         = feval(model.name,th);
solh        = sol;
solh.my     = solh.my(model.select,:);
tmp         = kalman_smoother(X,solh);
ayh         = tmp.x(:,ia);
byh         = detrend(tmp.x(:,ixi),0)/std(tmp.x(:,ixi));
cyh         = corrcoef([ltfpu conf wdg ycf ylw ayh byh]);
smooth.ayh  = ayh;
smooth.byh  = byh;
smooth.cyh  = cyh;


% T0          = 1968.75;
T0          = 1960;
T1          = 2007.75;
fs          = 12;
leg_        = 1;

subplot(221);plot(0,0);
set(gca,'fontname','times','fontsize',fs,'ylim',[-0.1 0.1]);
hold on
h=plot_nber([ayh ltfpu],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Technology Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs,'ylim',[-0.1 0.1],'xlim',[T0 T1])
if leg_
o=legend(h,'Techno. Shock','Adj. Solow Res.')
set(o,'fontname','times','fontsize',8)
end

subplot(222);plot(0,0);
set(gca,'fontname','times','fontsize',fs,'ylim',[-3.5 3.5]);
hold on
h=plot_nber([byh cf],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
set(h(1),'color','k','linewidth',1.5)
set(h(2),'color','r','linewidth',1)
%     title('Belief Shock','fontname','times','fontsize',fs)
set(gca,'fontname','times','fontsize',fs,'ylim',[-3.5 3.5],'xlim',[T0 T1])
if leg_
o=legend(h,'Belief Shock','Cons. Conf.','location','northwest');
set(o,'fontname','times','fontsize',8)
end

% subplot(233);plot(0,0);
% set(gca,'fontname','times','fontsize',fs,'ylim',[-3.5 3.5]);
% hold on
% h=plot_nber([byh wdg],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
% set(h(1),'color','k','linewidth',1.5)
% set(h(2),'color','r','linewidth',1)
% %     title('Belief Shock','fontname','times','fontsize',fs)
% set(gca,'fontname','times','fontsize',fs,'ylim',[-3.5 3.5],'xlim',[T0 T1])
% if leg_
% o=legend(h,'Belief Shock','Labor Wedge','location','northwest');
% set(o,'fontname','times','fontsize',8)
% end
% pause
% if prt_
printpdf('shocks_');
% end
close




% subplot(221);plot(0,0);set(gca,'fontname','times','fontsize',fs,'ylim',[-0.1 0.1]);
% hold on
% h=plot_nber([ayh ltfpu],T0,T1);
% set(h(1),'color','k','linewidth',1.5)
% set(h(2),'color','r','linewidth',1)
% %     title('Technology Shock','fontname','times','fontsize',fs)
% set(gca,'fontname','times','fontsize',fs,'ylim',[-0.1 0.1],'xlim',[T0 T1])
% if leg_
% o=legend(h,'Techno. Shock','Adj. Solow Res.');%,'location','southwest')
% set(o,'fontname','times','fontsize',8)
% end
% 
% subplot(222);plot(0,0);
% set(gca,'fontname','times','fontsize',fs,'ylim',[-3.5 3.5]);
% hold on
% h=plot_nber([byh ycf],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
% set(h(1),'color','k','linewidth',1.5)
% set(h(2),'color','r','linewidth',1)
% %     title('Belief Shock','fontname','times','fontsize',fs)
% set(gca,'fontname','times','fontsize',fs,'ylim',[-3.5 3.5],'xlim',[T0 T1])
% if leg_
% o=legend(h,'Belief Shock','Cons. Conf.','location','northwest');
% set(o,'fontname','times','fontsize',8)
% end
% 
% % subplot(233);plot(0,0);
% set(gca,'fontname','times','fontsize',fs,'ylim',[-3.5 3.5]);
% hold on
% h=plot_nber([byh ylw],T0,T1);%h=plot_nber([mbyh cf],T0,T1);
% set(h(1),'color','k','linewidth',1.5)
% set(h(2),'color','r','linewidth',1)
% %     title('Belief Shock','fontname','times','fontsize',fs)
% set(gca,'fontname','times','fontsize',fs,'ylim',[-3.5 3.5],'xlim',[T0 T1])
% if leg_
% o=legend(h,'Belief Shock','Labor Wedge','location','northwest');
% set(o,'fontname','times','fontsize',8)
% end
% pause
% % if prt_
% printpdf('shocks__purged');
% % end
% close


