function W=nwvar(theta,lags);

nbt     = size(theta,1);
mtheta  = mean(theta);
theta   = theta-repmat(mtheta,nbt,1);
W       = (theta'*theta)/(nbt-1);

for i   = 1:lags;
    tmp = (theta(i+1:nbt,:)'*theta(1:nbt-i,:))/(nbt-i-1);
    W   = W+(1-i/(lags+1))*(tmp+tmp');
end
