function [w,I_w]=periodogram(x)
n   = length(x);
I_w = abs(fft(x)).^2/n;
w   = 2*pi*(0:n-1)'/n;
% int rounds to nearest integer. We want to round up or take 1/2 + 1 to
% make sure we get the whole interval from [0, pi]
if rem(n,2)==0
    ind=n/2+1;
else
    ind=ceil(n/2);
end
w   = w(1:ind);
I_w = I_w(1:ind);

end