nchain      = 2;
NDraws      = 200000;
step        = 20;
%% Sticky Price
filemetro   = 'results/metro_nk_ci_timing_';
TH          = zeros(nchain*NDraws,25);
for i=1:nchain
    eval(['load ' filemetro int2str(i) '.mat'])
    TH((i-1)*NDraws+1:i*NDraws,:)   = theta;
end
Psp = prctile(TH(1:step:end,:),[50 5 95]);
spsel=[1 2 3 4 5 24 6 7 8 9 10 11 12 13 25 14 16 17 15 18 19 20 21 22 23];
%% Flexible Price
filemetro   = 'results/metro_real_util_ci';
TH          = zeros(nchain*NDraws,19);
for i=1:nchain
    eval(['load ' filemetro int2str(i) '.mat'])
    TH((i-1)*NDraws+1:i*NDraws,:)   = theta;
end
Pfp = prctile(TH(1:step:end,:),[50 5 95]);
fpsel=[1 2 3 4 5 0 6 7 8 9 10 11 12 13 0 14 16 17 15 18 19 0 0 0 0];
%%
for i=1:25
    if fpsel(i)>0
        fprintf(' %6.3f & [%5.3f,%5.3f] & %5.3f & [%5.3f,%5.3f]\\\\ \n',Pfp(:,fpsel(i)),Psp(:,spsel(i)))
    else
        fprintf(' -- & -- & %5.3f & [%5.3f,%5.3f] \\\\ \n',Psp(:,spsel(i)))
    end
end