function [strmom,irfa,irfs]=model_output_benchmark(theta,ficm,Names)
wmin      = 2*pi/32;
wmax      = 2*pi/6;

sol         = feval(ficm,theta,Names);
nsim        = 100;
T           = 192;
init        = 200;
long        = T+init;
smpl        = init+1:long;
rng(1234567890)
mom1        = 0;
mom2        = 0;
mom3        = 0;
STD         = sqrt(sol.sig); % ! only works for diagonal matrix
for s=1:nsim
    e   = STD*randn(2,long);
    sim = comp_data(sol,e);
    bpy = bpass(sim.y(smpl,1),6,32);
    bpc = bpass(sim.y(smpl,2),6,32);
    bpi = bpass(sim.y(smpl,3),6,32);
    bph = bpass(sim.y(smpl,4),6,32);
    bpp = bpass(sim.y(smpl,5),6,32);
    bpsr= bpass(sim.y(smpl,6),6,32);
    tmp = std([bpy bph bpc bpi bpp])/std(bpy);
    mom1= mom1+tmp'/nsim;
    tmp = corrcoef([bpy bpc bpi bph bpp bpsr]);
    mom2= mom2+[tmp(1,2:4) tmp(4,2:3) tmp(2,3)]'/nsim;
    mom3= mom3+[tmp(5,[1 4]) tmp(6,[1 4])]'/nsim;
end
mommod  = [mom1;mom2;mom3];
hor     = 20;
irfa        = comp_irf(sol,1,hor);%,sqrt(sol.sig(1,1)));
irfs        = comp_irf(sol,2,hor);%,sqrt(sol.sig(2,2)));

% for i=1:length(data.nfix)
%     eval([data.nfix{i} '=data.pfix(i);'])
% end
% for i=1:length(data.nest)
%     if data.pos(i)
%         tmp = sqrt(theta(i)*theta(i));
%     else
%         tmp = theta(i);
%     end
%     eval([data.nest{i} '=tmp;'])
% end
% vdec        = ses*ses*cumsum(irfs.y.^2)./(sea*sea*cumsum(irfa.y.^2)+ses*ses*cumsum(irfs.y.^2));
% ih          = [1 4 8 20];
% vdec        = 100*vdec(ih,1:5);
% disp(repmat('=',1,40))
% for i=1:4
%     fprintf('%2d & %6.2f & %6.2f & %6.2f & %6.2f & %6.2f \\\\ \n',ih(i),vdec(i,:))
% end
% disp(repmat('=',1,40))
% Vxi     = vdecfreq(sol,wmin,wmax,1:5);
% fprintf('& %6.2f & %6.2f & %6.2f & %6.2f & %6.2f \\\\ \n',Vxi)
% disp(repmat('=',1,40))
strmom      = sprintf(' & %6.2f ',mommod(1));
for i=2:length(mommod);
    strmom=char(strmom,sprintf(' & %6.2f ',mommod(i)));
end
% VV=Vxi([1 3 4 2 5]);
% for i=1:5;
%     strmom=char(strmom,sprintf(' & %6.2f ',VV(i)));
% end
