function data=comp_data(sol,shocks,varargin)
long    = size(shocks,2);
nx      = size(sol.mx,1);
X       = zeros(nx,long);
if nargin>2
    X(:,1)  = varargin{1};
else
    X(:,1)  = sol.me*shocks(:,1);
end
for t=2:long;
    X(:,t)  = sol.mx*X(:,t-1)+sol.me*shocks(:,t);
end
Y       = sol.my*X;
data.y  = Y';
if isfield(sol,'myf')
    data.yf = cell(5,1);
    for i   = 1:5;
        data.yf{i}  = (sol.myf{i}*X)';
        data.xf{i}  = (sol.mxf{i}*X)';
    end
end
data.x  = X';
