function [RY,RX]=comp_irf(model,init,nrep)

MX  = model.mx;
ME  = model.me;
MY  = model.my;

nx  = size(MX,1);
ny  = size(MY,1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                             %
% Impulse response functions                                                  %
%                                                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RX      = zeros(nx,nrep);
RX(:,1) = ME*init;
for i=2:nrep;
    RX(:,i)	    = MX*RX(:,i-1);   
end
RY      = (MY*RX)'; % Y_t
RX      = RX';      % X_t


