function mom=comp_mombp(sol,sely)

addpath('../method');
rng(1234567890,'twister');
%%
%
% some file names
%
ne      = size(sol.me,2);
nx      = size(sol.mx,2);
T       = 192;
init    = 200;
nsim    = 100;
smpl    = (init+1):(T+init);
sstd    = 0;
scor    = 0;
ccorh   = 0;
ccory   = 0;
for i=1:nsim
    Sig     = chol(sol.sig)';
    E       = randn(ne,T+init);
    u       = Sig*E;
    X       = zeros(nx,T+init);
    X(:,1)  = sol.me*u(:,1);
    for t=2:T+init
        X(:,t)   = sol.mx*X(:,t-1)+sol.me*u(:,t);
    end
    Y       = (sol.my(sely,:)*X)';
    Y       = Y(smpl,:);
    BpY     = bpass(Y,6,32);
    sstd    = sstd+std(BpY)/nsim;
    scor    = scor+corrcoef(BpY)/nsim;
%     tmp     = autocorr(BpY(:,1),8);
%     acy     = acy+tmp.ac/nsim;
%     tmp     = autocorr(BpY(:,2),8);
%     acp     = acp+tmp.ac/nsim;
%     tmp     = autocorr(BpY(:,3),8);
%     acr     = acr+tmp.ac/nsim;
%     ccorh   = ccorh+crosscorr(BpY(:,2),BpY(:,5),20)/nsim;
%     ccory   = ccory+crosscorr(BpY(:,1),BpY(:,5),20)/nsim;
end
mom.std=sstd;
mom.cor=scor;
% mom.cry=ccory;
% mom.crh=ccorh;
