function mom=comp_momhp(solution,select,ldlg,indy)
MX      = solution.mx;
ME      = solution.me;
MY      = solution.my;
SIG     = solution.sig;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                             %
%                    Moments th?oriques                       %
%                                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
grid    = 128;      % Grille de valeurs pour IFFT. Puissance de 2
hplbd   = 1600;    % Lambda de HP
nbldlg  = ldlg+1;
nsel    = length(select);

freqs   = 0:(2*pi)/grid:(2*pi*(1-0.5/grid)); 
hpgain  = (4*hplbd*(1-cos(freqs)).^2)./(1+4*hplbd*(1-cos(freqs)).^2); 
hp2     = hpgain.*hpgain;
im      = sqrt(-1);
r2pi    = 1/(2*pi);
hpfilt  = zeros(grid,nsel*nsel);
for gp=1:grid;
    zi          = exp(-im*freqs(gp));
    fom1        = MY(select,:)*((eye(length(MX))-MX*zi)\ME);
    fom         = r2pi*(fom1*SIG*fom1');
    fom         = hp2(gp)*fom;
    hpfilt(gp,:)= fom(:)';
end;
ACV     = 2*pi*real(ifft(hpfilt));
COV     = reshape(ACV(1,:),nsel,nsel);
STD     = sqrt(diag(COV))';
COR     = COV./(STD'*STD);
%
% Corr(Y(t),Y(t+k)) k=-4,...,4
%
ACY0    = ones(nbldlg-1,1)*(STD.^2);
ACY     = ACV(2:nbldlg,nsel*(0:nsel-1)+(1:nsel))./ACY0;
mom.std = STD;
mom.cor = COR;
mom.acy = ACY;
%
% Corr(Y(t),X(t+k)) k=-4,...,4
%
nbldlg  = ldlg+1;
STDY    = STD(indy);
Ysel    = nsel*(0:nsel-1)+indy;
CORY0   = STDY*ones(nbldlg,1)*STD;
CORY1   = ACV(1:nbldlg,Ysel)./CORY0;
Ysel    = (indy-1)*nsel+1:indy*nsel;
CORY2   = ACV(1:nbldlg,Ysel)./CORY0;
CORY    = [flipud(CORY1);CORY2(2:nbldlg,:)];
mom.cory= CORY;
