function mom=comp_momraw(sol,sel)
PI  = sol.my(sel,:);
MSS = sol.mx;
MSE = sol.me;
SIG = sol.sig;
ls	= size(MSS,1);
VE	= MSE*SIG*MSE';
VE	= VE(:);
VS	= kron(MSS,MSS);
VS	= (eye(size(VS))-VS)\VE;
VS	= reshape(VS,ls,ls);
VX	= PI*VS*PI';

MX  = MSS;
nlags   = 4;
ny      = size(PI,1);
ACX = zeros(ny,nlags);
for i=1:nlags;
    VY      = PI*(MX*VS)*PI';
    ACX(:,i)= diag(VY)./diag(VX);
    MX      = MX*MSS;
end

mom.std = sqrt(diag(VX));
mom.cor = VX./(mom.std'*mom.std);
mom.acy = ACX;

SEY     = zeros(5,ny);
CEY     = zeros(5,ny);
VE      = reshape(VE,ls,ls);
MY      = PI;
tmp     = (MY-sol.myf{1}(sel,:))*VS*(MY-sol.myf{1}(sel,:))';
tmp     = sqrt(diag(tmp));
SEY(1,:)= tmp(:)';

tmpc    = (MY-sol.myf{1}(sel,:))*VS*MY(1,:)';
CEY(1,:)= (tmpc(:)./(tmp(:)*mom.std(1)))';
MX      = eye(ls);
MY      = PI*sol.mx;
SUM     = VE;
for i=2:5;
    tmp     = (MY-sol.myf{i}(sel,:))*VS*(MY-sol.myf{i}(sel,:))'+PI*SUM*PI';
    tmp     = sqrt(diag(tmp));
    tmpc    = (MY-sol.myf{i}(sel,:))*VS*MY(1,:)';
    MY      = MY*sol.mx;
    SUM     = VE+sol.mx*SUM*sol.mx';
    SEY(i,:)= tmp(:)';
    CEY(i,:)= (tmpc(:)./(tmp(:)*mom.std(1)))';    
end
mom.stde    = SEY;
mom.core    = CEY;
% Autocorrelation of forecast errors
MX1 = MSS;
MX2 = MX1*MSS;
MX3 = MX2*MSS;
ACE = zeros(5,ny);
% eta(t|t)
MY  = PI;
M0  = MY-sol.myf{1}(sel,:);
ACE(1,:) = (diag(M0*MSS*VS*M0')./(SEY(1,:)'.*SEY(1,:)'))';
% eta(t+1|t)
MY  = MY*sol.mx;
M1  = MY-sol.myf{2}(sel,:);
ACE(2,:) = (diag(M1*MSS*VS*M1'+M1*VE*MY')./(SEY(2,:)'.*SEY(2,:)'))';
% eta(t+2|t)
MY  = MY*sol.mx;
M2  = MY-sol.myf{3}(sel,:);
ACE(3,:) = (diag(M2*MSS*VS*M2'+M2*VE*MX1'*MY'+MY*MX1*VE*MY')./(SEY(3,:)'.*SEY(3,:)'))';
% eta(t+3|t)
MY  = MY*sol.mx;
M3  = MY-sol.myf{4}(sel,:);
ACE(4,:) = (diag(M3*MSS*VS*M3'+M3*VE*MX2'*MY'+MY*MX1*VE*MY'+MY*MX2*VE*MX1'*MY')./(SEY(4,:)'.*SEY(4,:)'))';
% eta(t+4|t)
MY  = MY*sol.mx;
M4  = MY-sol.myf{5}(sel,:);
ACE(5,:) = (diag(M4*MSS*VS*M4'+M4*VE*MX3'*MY'+MY*MX1*VE*MY'+MY*MX2*VE*MX1'*MY'+MY*MX3*VE*MX2'*MY')./(SEY(5,:)'.*SEY(5,:)'))';
mom.ace = ACE;
