function convplot(file,nchain,latexnames)
for i=1:nchain
    load([file.folder '/' file.metro int2str(i)])
    th{i}=theta;
end

step    = 10;
[N,J]   = size(th{1});
k       = 1;
T       = (1:N)';
fig     = 1;
for j=1:J
    tmp = zeros(N,nchain);
    for i=1:nchain
        tmp(:,i)    = cumsum(th{i}(:,j))./T;
    end
    subplot(3,3,k);h=plot(tmp(1:step:N,:));
    set(gca,'fontname','times','fontsize',12);
    title(latexnames{j},'fontname','times','fontsize',12);
    if or(rem(k,9)==0,j==J)
        k=1;
        printpdf(strcat(file.folder,'/m1_',file.metro,'_',int2str(fig)));
        fig=fig+1;
        figure;
    else
        k=k+1;
    end
end
k=1;
fig=1;
figure
for j=1:J
    tmp = zeros(N,nchain);
    for i=1:nchain
        mth         = mean(th{i}(:,j));
        tmp(:,i)    = cumsum((th{i}(:,j)-mth).*(th{i}(:,j)-mth))./T;
    end
    subplot(3,3,k);h=plot(tmp(1:step:N,:));
    set(gca,'fontname','times','fontsize',12);
    title(latexnames{j},'fontname','times','fontsize',12);
    if or(rem(k,9)==0,j==J)
        k=1;
        printpdf(strcat(file.folder,'/m2_',file.metro,'_',int2str(fig)))        
        fig=fig+1;
        figure;
    else
        k=k+1;
    end
end