function [obj,sol,loglh,jointprior]=evalpost(theta,data,model,datapriors,bounds)

% if nargin<5;
%     bounds  = repmat([-1e20 1e20],size(theta(:),1),1);
% end
switch upper(model.type)
    case 'FD'
        llfunc  = 'fdloglike';
    otherwise
        llfunc  = 'loglike';
end

% if and((theta(:)>=bounds(:,1)),(theta(:)<bounds(:,2)))
    tol             = 1e-12;
    jointprior      = fprior(theta,datapriors);
    if abs(jointprior)<tol;
        loglh       =-1e20;
        obj         =-1e20;
        sol.id      = 2;
    else
        [loglh,sol] = feval(llfunc,data,theta,model);
        obj         = loglh+jointprior;
        if sol.id~=0
            sol.id          = 2;
            loglh           =-1e20;
            jointprior      =-1e20;
            obj             =-1e20;
        end
    end
% else
%     sol.id          = 2;
%     loglh           =-1e20;
%     jointprior      =-1e20;
%     obj             =-1e20;
% end;