function res=filtervar(Y,x,k)
T           = size(Y,1);
Y           = Y(k+1:T,:);
nx          = k+2;
X           = ones(T-k,k+2);
X(:,2)      = x(k+1:T);
for i=1:k
    X(:,2+i)= x(k+1-i:T-i);
end
B           = X\Y;
res.fit     = X*B;
res.resid   = Y-X*B;
res.see     = cov(res.resid);
lds         = log(det(res.see));
res.aic     = lds+2*nx*k/T;
res.hq      = lds+2*log(log(T))*nx*k/T;
res.sc      = lds+2*log(T)*nx*k/T;
