function[jprior]=fprior(param,priors)

jprior=0;
for i=1:size(param,1);
    
    switch upper(char(priors.type{i}));
        case 'GAMMA'
            a       = priors.mean(i);
            b       = priors.std(i);
            tmp     = lpdfgam(param(i),a,b);
        case 'BETA'
            a       = priors.mean(i);
            b       = priors.std(i);
            tmp     = lpdfbeta(param(i),a,b);
        case 'INVGAMMA'
            a       = priors.mean(i);
            b       = priors.std(i);
            tmp     = lpdfig(param(i),a,b);
        case 'UNIFORM'
            a       = priors.mean(i);
            b       = priors.std(i);
            tmp     = 1/(b-a);
        otherwise
            a       = priors.mean(i);
            b       = priors.std(i);
            tmp     = lpdfnor(param(i),a,b);
    end
%     fprintf('type: %8s, a=%8.4f, b=%8.4f, tmp=%12.8f\n',priors.type{i},a,b,tmp);
    jprior  = jprior+tmp;
end
