function xsim=get_states(theta,ficm,Y,graph,file,e,smsr,smh,T0,T1)
% load(file.data);
fs          = 12;
T       = size(Y,1);
% hp      = hpmat(T,1600);

ly      = Y(:,1);
lh      = Y(:,2);
ltfpu   = Y(:,3);
ltfp    = Y(:,4);
Y       = Y(:,1:2);
innov   = e.yh(:);
innov   = fcsolve(@fget_states,innov,[],Y,[1 4],theta,ficm,smh);
innov   = reshape(innov,T,2);
sol     = feval(ficm,theta);
solks   = sol;
solks.my= solks.my([1 4],:);
xsim    = comp_data(solks,innov',smh.x(1,:)');

if graph
    X           = xsim.x;
    X(:,4)      = zeros(size(X,1),1);
    cfy         = (sol.my*X')';
    %     Y           = [cfy(:,1)-hp\cfy(:,1) ly-hp\ly];
    Y           = [bpass(cfy(:,1),6,32) bpass(ly,6,32)];
    subplot(221);h=plot_nber(Y,T0,T1);
    set(h(2),'color','r','linewidth',1.5)
    title('Output','fontname','times','fontsize',fs)
    o=legend(h,'TFP Shock','Data','location','southeast');
    set(o,'fontname','times','fontsize',8)
    set(gca,'fontname','times','fontsize',fs)
    %     Y           = [cfy(:,4)-hp\cfy(:,4) lh-hp\lh];
    Y           = [bpass(cfy(:,4),6,32) bpass(lh,6,32)];
    subplot(222);h=plot_nber(Y,T0,T1);
    set(h(2),'color','r','linewidth',1.5)
    title('Hours Worked','fontname','times','fontsize',fs)
    set(gca,'fontname','times','fontsize',fs)
    %     pause
    printpdf([file.tfp,'_yh']);
    close
    
    subplot(221);h=plot_nber([xsim.x(:,3) ltfpu],T0,T1);
    set(h(2),'color','r','linewidth',1.5)
    title('Technology Shock','fontname','times','fontsize',fs)
    o=legend(h,'TFP Shock','Adj. Solow Res.');%,'location','southwest')
    set(o,'fontname','times','fontsize',8)
    set(gca,'fontname','times','fontsize',fs)
    subplot(222);h=plot_nber(xsim.x(:,4),T0,T1);
    title('Belief Shock','fontname','times','fontsize',fs)
    set(gca,'fontname','times','fontsize',fs)
    %     pause
    printpdf([file.sh,'_yh']);
    close
end

%%
Y       = [ly ltfp];
innov   = e.ysr(:);
innov   = fcsolve(@fget_states,innov,[],Y,[1 7],theta,ficm,smsr);
innov   = reshape(innov,T,2);
sol     = feval(ficm,theta);
solks   = sol;
solks.my= solks.my([1 7],:);
xsim    = comp_data(solks,innov',smsr.x(1,:)');
if graph
    X           = xsim.x;
    X(:,4)      = zeros(size(X,1),1);
    cfy         = (sol.my*X')';
    %     Y           = [cfy(:,1)-hp\cfy(:,1) ly-hp\ly];
    Y           = [bpass(cfy(:,1),6,32) bpass(ly,6,32)];
    subplot(221);h=plot_nber(Y,T0,T1);
    set(h(2),'color','r','linewidth',1.5)
    title('Output','fontname','times','fontsize',fs)
    o=legend(h,'TFP Shock','Data','location','southeast');
    set(o,'fontname','times','fontsize',8)
    set(gca,'fontname','times','fontsize',fs)
    %     Y           = [cfy(:,4)-hp\cfy(:,4) lh-hp\lh];
    Y           = [bpass(cfy(:,4),6,32) bpass(lh,6,32)];
    subplot(222);h=plot_nber(Y,T0,T1);
    set(h(2),'color','r','linewidth',1.5)
    title('Hours Worked','fontname','times','fontsize',fs)
    set(gca,'fontname','times','fontsize',fs)
    %     pause
    printpdf([file.tfp,'_ytfp']);
    close
    
    subplot(221);h=plot_nber([xsim.x(:,3) ltfpu],T0,T1);
    set(h(2),'color','r','linewidth',1.5)
    title('Technology Shock','fontname','times','fontsize',fs)
    o=legend(h,'TFP Shock','Adj. Solow Res.');%,'location','southwest')
    set(o,'fontname','times','fontsize',8)
    set(gca,'fontname','times','fontsize',fs)
    subplot(222);h=plot_nber(xsim.x(:,4),T0,T1);
    title('Belief Shock','fontname','times','fontsize',fs)
    set(gca,'fontname','times','fontsize',fs)
    %      pause
    printpdf([file.sh,'_ytfp']);
    close
end