function irf=irf_model_mode(TH,model,file,nom_)
nrep    = 2000;
idx     = 1:4;
str     = {'Output','Consumption','Investment','Hours Worked','Inflation Rate','Nominal Interest Rate'};
sol     = feval(model.name,TH);
ns      = length(model.ish);
irf     = cell(ns,1);
if nom_
    idx=[1:4 6 7];
    for i=1:ns
        irf{i}  = comp_irf(sol,model.ish(i),nrep,sqrt(sol.sig(model.ish(i),model.ish(i))));
        tmp     = irf{i}.y.*(abs(irf{i}.y)>1e-6);
        
        ya      = tmp(:,idx(1))';
        ca      = tmp(:,idx(2))';
        ia      = tmp(:,idx(3))';
        ha      = tmp(:,idx(4))';
        pa      = tmp(:,idx(5))';
        ra      = tmp(:,idx(6))';
        
        fs=12;
        
%         x=(1:nrep)';
%         y=ya;
%         subplot(231);plot(x,y,'k-')
%         title(str{1},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         
%         y=ca;
%         subplot(232);plot(x,y,'k-');
%         title(str{2},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         
%         y=ia;
%         subplot(233);plot(x,y,'k-');
%         title(str{3},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         
%         y=ha;
%         subplot(234);plot(x,y,'k-');
%         title(str{4},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         
%         y=pa;
%         subplot(235);plot(x,y,'k-');
%         title(str{5},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         
%         y=ra;
%         subplot(236);plot(x,y,'k-');
%         title(str{6},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         pause
%         printpdf(sprintf('%s_%s_mode',file,model.sh{i}));
%         close
    end
    
else
    idx=1:4;
    for i=1:ns
        
        irf{i}  = comp_irf(sol,model.ish(i),nrep,sqrt(sol.sig(model.ish(i),model.ish(i))));
        tmp     = irf{i}.y.*(abs(irf{i}.y)>1e-6);
        
%         ya      = tmp(:,idx(1))';
%         ca      = tmp(:,idx(2))';
%         ia      = tmp(:,idx(3))';
%         ha      = tmp(:,idx(4))';
%         
%         fs=12;
%         
%         x=(1:nrep)';
%         figure
%         y=ya;
%         subplot(241);plot(x,y,'k-')
%         title(str{1},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         
%         y=ca;
%         subplot(242);plot(x,y,'k-');
%         title(str{2},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         
%         y=ia;
%         subplot(243);plot(x,y,'k-');
%         title(str{3},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         
%         y=ha;
%         subplot(244);plot(x,y,'k-');
%         title(str{4},'fontname','times','fontsize',fs);
%         xlabel('Quarters','fontname','times','fontsize',fs);
%         set(gca,'fontname','times','fontsize',fs);
%         pause
%         printpdf(sprintf('%s_%s_mode',file,model.sh{i}));
%         close
    end
end