function h=irfplot(X,Y,UP_Y,LW_Y,titre,fs,leg,varargin)
tt=0;
if nargin>4
    if ~isempty(titre);
        tt=1;
    end;
    if (nargin<6)|(isempty(fs));
        fs=14;
    end
end

% col={'k','k','k','k'};
% styl={'-','-','-','-'};
% MS=[0.1 0.1 0.1 5];
h=plot(X,Y,'w');
% for i=1:length(h);
%     set(h(i),'linestyle',[]);
% end
if (nargin>6)
    if ~isempty(leg)
    [o,h]=legend(leg,'Location','NorthEast');
    %set(o(:),'interpreter','latex','fontname','times','fontsize',12)
    set(o(:),'fontname','times','fontsize',12)
    end
end
hpatch = patch([X;flipud(X)],[LW_Y;flipud(UP_Y)],[.85 .85 .85]); % gris Martialou
set(hpatch,'linestyle','none')
hold on
h=plot(X,Y);
% for i=1:length(h);
%     set(h(i),'linewidth',1,'color',char(col{i}),'linestyle',styl{i},'marker','o','markersize',MS(i));
% end
Z       = [Y(:);UP_Y(:);LW_Y(:)];
[tmp,i] = max(Z);
limup   = max(max(Z),1.05*tmp*sign(tmp));
[tmp,i] = min(Z);
liminf  = min(min(Z),1.05*tmp*sign(tmp));
xlabel('Quarters','fontname','times','fontsize',fs)
set(gca,'Layer','top')
if nargin>7
    set(gca,'xlim',[X(1);X(end)],'ylim',varargin{1},'fontname','times','fontsize',fs)
else
    set(gca,'xlim',[X(1);X(end)],'ylim',sort([liminf limup]),'fontname','times','fontsize',fs)
end
% set(gca,'xlim',[X(1);X(end)],'fontname','times','fontsize',fs)
grid
if tt;
    title(titre,'fontname','times','fontsize',fs,'fontweight','normal')
end
box on;
hold off;