function [obj,ll]=objective(param,data,fmodel,datapriors,bounds,fixed,itheta,ifixed,varargin)

if isfield(fmodel,'transfo');
    if ~isempty(fmodel.transfo)
        param=feval(fmodel.transfo,param);
    end
end

% if nargin<5;
%     bounds  = repmat([-1e20 1e20],size(param(:),1),1);
% end
%
%
% if and((param(:)>=bounds(:,1)),(param(:)<bounds(:,2)))
npar            = size(param(:),1);
nfix            = size(fixed(:),1);
theta           = zeros(npar+nfix,1);
theta(itheta)   = param(:);
theta(ifixed)   = fixed(:);
ll              =-evalpost(theta,data,fmodel,datapriors,bounds);

if isfield(fmodel,'constraint');
    const   = feval(fmodel.constraint,theta,varargin{1},fmodel);
else
    const   = 0;
end

obj     = ll+const;
% else
%     obj=1e20;
% end