function posterior_moment(param,model,step,fixed,ith,ifix)

nmom        = 22;
[N,npar]    = size(param);
nfix        = size(fixed(:),1);
idth        = 1:step:N;
N           = length(idth);
res         = zeros(N,nmom);

th          = zeros(npar+nfix,1);
th(ifix)    = fixed(:);
for i=1:N
    th(ith) = param(idth(i),:)';
    sol     = feval(model.name,th);
    mom     = comp_momhp(sol,1:8);
    
    sol1        = sol;
    nx          = size(sol.mx,1);
    ns          = size(sol.me,2);
    sol1.mx     = [sol1.mx zeros(nx,3);sol1.my(1:3,:) zeros(3)];
    sol1.my     = [sol1.my(1:3,:) zeros(3)]-[zeros(3,nx) eye(3)];
    for i=1:5
        sol1.myf{i}     = [sol1.myf{i}(1:3,:) zeros(3)]-[zeros(3,nx) eye(3)];
    end
    sol1.me     = [sol1.me;zeros(3,ns)];
    mom1        = comp_momraw(sol1,1:3);
    AC          = zeros(4,1);
    for i=1:4;
        %     AC(3*(i-1)+1:3*i)	= mom1.acy(1:3,i);
        AC(i)	= mom1.acy(1,i);
    end
    tmp         = [mom.std(1);mom.std(2:5)'/mom.std(1);mom.cor(1,2:5)';mom.corh(:,4);AC];
    [outy,outdy]=corrdyerr(sol)
    res(i,:)= [tmp outy' outdy'];
end
avres       = mean(res)';
mdres       = median(res)';
lwres       = prctile(res,2.5)';
hgres       = prctile(res,97.5)';
disp([avres mdres lwres hgres]);
