function tmp=simprior(priors,n,bounds);
npar= size(priors.mean(:),1);
tmp = zeros(n,npar);
for i   = 1:npar;
    switch upper(char(priors.type{i}));
        case 'GAMMA'
            a       = priors.mean(i)*priors.mean(i)/(priors.std(i)*priors.std(i));
            b       = priors.std(i)*priors.std(i)/priors.mean(i);
%             tmp(:,i)= gam_rnd(a,b,n,1);
            tmp(:,i)= b*gamm_rnd(n,a);
        case 'BETA'
            a       = (1-priors.mean(i))*priors.mean(i)*priors.mean(i)/(priors.std(i)*priors.std(i))-priors.mean(i);
            b       = a*(1/priors.mean(i)-1);
            tmp(:,i)= beta_rnd(n,a,b);
        case 'INVGAMMA'
%             if isinf(priors.std(i))
%                 b   = 4;
%             else
%                 b   = 2*(2+priors.mean(i)*priors.mean(i)/(priors.std(i)*priors.std(i)));
%             end
%             a       = sqrt(priors.mean(i)*(b-2)/b);
            cst     = sqrt(2)*gamma(1.5)/gamma(2);
            a       = priors.mean(i);
            a       = a/cst;
            b       = priors.std(i);
            temp    = sum(randn(floor(b),n).^2)';
            tmp(:,i)= sqrt(b*a^2./temp);            
        case 'UNIFORM'
            a       = priors.mean(i);
            b       = priors.std(i);
            tmp(:,i)= a+rand(n,1)*(b-a);
        otherwise
            a       = priors.mean(i);
            b       = priors.std(i);
            tmp(:,i)= a+b*randn(n,1);
    end
end
if nargin>2;
    [i,j]   = find((tmp<repmat(bounds(:,1)',n,1))|(tmp>repmat(bounds(:,2)',n,1)));
    keep    = setdiff(1:n,i);
    tmp     = tmp(keep,:);
    fprintf('%d draws discarded\n',n-size(tmp,1))
end