function term=termstructot(sol,K,rho,stdxi,nby)
GAMfx   = sol.gamfx;
GAMfz   = sol.gamfz;
OMx     = sol.omx;
OMz     = sol.omz;
DELT    = sol.delt;
Q       = sol.q;

nxf     = size(GAMfx,1);
S       = zeros(nxf,K+1);
tmp     =-(GAMfz*DELT);
S(:,1)  = tmp(:,1);
for k=1:K
    SUM = 0;
    for j=0:k-1
        SUM = SUM+OMx^(k-1-j)*OMz*DELT*Q^j;
    end
	tmp     =-(GAMfx*SUM+GAMfz*DELT*Q^k);
    S(:,k+1)= tmp(:,1);
end
% irf     = comp_irf(sol,nbexi,20);
% term    = -rho*kron(S(nby,:),irf.x(:,nbxi)*stdxi);
term    = -rho*S(nby,:)*stdxi;
